# Testfälle roman_to_int, str -> int

# 1. Einzelne römische Ziffern
# Eingabe: "I" → Erwartete Ausgabe: 1
# Eingabe: "V" → Erwartete Ausgabe: 5
# Eingabe: "X" → Erwartete Ausgabe: 10
# Eingabe: "L" → Erwartete Ausgabe: 50
# Eingabe: "C" → Erwartete Ausgabe: 100
# Eingabe: "D" → Erwartete Ausgabe: 500
# Eingabe: "M" → Erwartete Ausgabe: 1000

#2. Mehrere gleiche Ziffern hintereinander (einfache Addition)
# Eingabe: "II" → Erwartete Ausgabe: 2
# Eingabe: "XX" → Erwartete Ausgabe: 20
# Eingabe: "CC" → Erwartete Ausgabe: 200
# Eingabe: "MM" → Erwartete Ausgabe: 2000

#3. Subtraktive Notation
# Eingabe: "IV" → Erwartete Ausgabe: 4
# Eingabe: "IX" → Erwartete Ausgabe: 9
# Eingabe: "XL" → Erwartete Ausgabe: 40
# Eingabe: "XC" → Erwartete Ausgabe: 90
# Eingabe: "CD" → Erwartete Ausgabe: 400
# Eingabe: "CM" → Erwartete Ausgabe: 900

#4. Komplexe Zahlen
# Eingabe: "MCMXCIV" → Erwartete Ausgabe: 1994
#Eingabe: "XIV" → Erwartete Ausgabe: 14
#Eingabe: "CDXLIV" → Erwartete Ausgabe: 444


import sys
import os
import unittest

# Füge das src-Verzeichnis zum Python-Pfad hinzu
sys.path.append(os.path.abspath(os.path.join(os.path.dirname(__file__), '../src')))

from src.romannumerals import RomanNumber  # Importiere die zu testende Klasse

class TestRomanConverter(unittest.TestCase):
    def setUp(self):
        self.converter = RomanNumber()

    def test_single_digits(self):
        self.assertEqual(self.converter.convert("I"), 1)
        self.assertEqual(self.converter.convert("V"), 5)
        self.assertEqual(self.converter.convert("X"), 10)

    def test_multiple_digits(self):
        self.assertEqual(self.converter.convert("II"), 2)
        self.assertEqual(self.converter.convert("XX"), 20)
        self.assertEqual(self.converter.convert("VI"), 6)

    def test_subtractive_notation(self):
        self.assertEqual(self.converter.convert("IV"), 4)
        self.assertEqual(self.converter.convert("IX"), 9)
        self.assertEqual(self.converter.convert("XL"), 40)
        self.assertEqual(self.converter.convert("XC"), 90)

    def test_complex_numbers(self):
        self.assertEqual(self.converter.convert("MCMXCIV"), 1994)
        self.assertEqual(self.converter.convert("CDXLIV"), 444)

if __name__ == "__main__":
    unittest.main()

# python -m unittest testsothers.OrlandoTestRoman -v